/*
 * Interactive binary matrix calculator
 * 2022-06-16: Created by Abdalla Ahmed.
 *
 */

#include "matrix.h"
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <vector>
#include <string>
#include <random>
#include <getopt.h>

Matrix readMatrix(char *prompt) {
    printf("%s\n", prompt);
    return Matrix(stdin);
}

const char *USAGE_MESSAGE = "Usage: %s [options]\n"
"Options:\n"
;

int main(int argc, char** argv) {
    BitStream bsRand;
    while (true) {
        char choice;
        printf(
            "(i)nvert, (m)ultiply, (s)um/(s)ubtract, is (d)yadic pair?, "
            "(l)v-decompose, print (c) format\n"
            "Enter a letter or ctrl-d to end:"
        );
        scanf(" %c", &choice);
        if (feof(stdin)) break;
        switch (choice) {
            case 'i': {
                Matrix x = readMatrix("Enter matrix to invert:");
                printf("Inverse matrix is:\n");
                x.inverse().print(stdout);
                break;
            }
            case 'm': {
                Matrix x = readMatrix("Enter left multiplicant:");
                Matrix y = readMatrix("Enter right multiplicant:");
                printf("Product matrix is:\n");
                (x * y).print(stdout);
                break;
            }
            case 's': {
                Matrix x = readMatrix("Enter first addend:");
                Matrix y = readMatrix("Enter second addend:");
                printf("Sum matrix is:\n");
                (x + y).print(stdout);
                break;
            }
            case 'l': {
                Matrix x = readMatrix("Enter matrix to decompose:");
                Matrix l, v;
                x.lvDecompose(l, v);
                printf("l:\n"); l.print(stdout);
                printf("v:\n"); v.print(stdout);
                break;
            }
            case 'd': {
                Matrix x = readMatrix("Enter first matrix:");
                Matrix y = readMatrix("Enter second matrix:");
                printf(
                    "The two matrix are%s a dyadic pair\n",
                    x.isDyadicPair(y) ? "" : " not"
                );
                break;
            }
            case 'c': {
                Matrix x = readMatrix("Enter matrix:");
                x.printC();
                break;
            }
        }
    }
    printf("\n");
}

